#!/usr/bin/env python

# usage: oscp-remote.py <HOST> <PORT>
# simple remote interface to oscp player by ariel/KotCzarny

import sys; import time
import os;
from os.path import expanduser

import pygtk; pygtk.require('2.0'); import gtk; import socket; import gobject
import pango;

class oscp_remote:
 #user configurables, presets:
 # iconset: use negative number to use gtk stock icons instead of labels
 HOST="127.0.0.1"; PORT=44322;
 #HOST="192.168.2.62"
 #HOST="192.168.1.80"
 #HOST="192.168.1.60"
 #HOST="127.0.0.1"
 # ss: style scale factor (for style_me==3)
 #id="pc"; style_me=3; ss=1.0; dpi=96; iconset=-1; small=1; defsize=7; volume_as_slider=1
 #id="n8x0"; style_me=0; ss=1.5; dpi=225; iconset=-2; small=1; defsize=7; volume_as_slider=1
 id="n900"; style_me=2; ss=1.45; dpi=267; iconset=-2; small=1; defsize=7; volume_as_slider=1
 oscp_bin="oscp"
 i_like_buttons=0
 LISTTYPE=2
 pixpa="/opt/oscp/share/images/" # pixmap path
 #end of user configurables

 lastperc=-1; lmax=0; lcur=0; hdb=""; cfail=1; curname=""; state=0; time=0; ttime=0
 focus=0; favRstate=0; ww=0; wh=0

 def handle_dbus(self, signal, button): print "handle_dbus: "+str(signal)+","+str(button)

 def handle_hsb(self, signal, button):
  #print "handle_hsb: "+str(signal)+","+str(button)
  #if(button=="phone"): self.playpause(None,None);
  if(button=="phone"): self.next(None,None);
  elif(button=="next-song"): self.next(None,None);
  elif(button=="previous-song"): self.prev(None,None);
  elif(button=="play-cd"): self.playpause(None,None);

 def handle_focus(self, signal, button):
  #print "handle_dbus: "+str(signal)+","+str(button)
  if(self.focus==0): self.focus=time.time()
  else:
   dt=time.time()-self.focus; self.focus=0
   if(dt<0.5): self.ffwd(None,None)
   else: self.playpause(None,None)

 if(style_me==0): local_gtkrc=""
#######//pc styled lite//#######
 elif(id=='pc'):
  if(style_me==1): local_gtkrc="""  style "default"
{ GtkCheckButton::indicator-size=9  #GtkPaned::handle-size=6  #GtkWidget::interior-focus=0
 GtkRange::trough-border=0  GtkRange::slider-width=12  GtkRange::stepper-size=15
 GtkRange::stepper-spacing=0  GtkRange::trough-side-details=0  GtkRange::slider-width=24
 GtkWidget::focus-line-width=0  GtkWidget::focus-padding=0  xthickness=0  ythickness=0

 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#666" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"

# ls /usr/lib/gtk-2.0/2.*/engines/*.so
# clearlooks glide industrial pixmap smooth crux-engine hcengine mist redmond95 thinice
engine "thinice" { }
#engine "crux-engine" { }
}  class "GtkWidget" style "default" """

######//pc styled//#######
  elif(style_me==2): ww=275*2; wh=116*2; local_gtkrc=""" pixmap_path "/opt/oscp/share/images"
style "default"
{ GtkWidget::focus-line-width=0  GtkWidget::focus-padding=0  xthickness=0  ythickness=0
 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee"  engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.bmp" }
  image { function=BOX file="blank.bmp" }
}}
style "pixmap_wide" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" ythickness=1 xthickness=1
 GtkProgressBar::min-horizontal-bar-height=24  engine "pixmap" {
  image { function=BOX state=PRELIGHT file="a-blank-wide.bmp" }
  image { function=BOX file="blank-wide.bmp" }
}}
class "GtkButton" style "pixmap"
class "GtkProgressBar" style "pixmap_wide"
class "GtkWidget" style "default"
"""
######//pc styled (winamp skin)//#######
  elif(style_me==3):
   gtk.stock_add([('i_prev',"",0,0,"")])
   ww=275*2; wh=116*2; local_gtkrc=""" pixmap_path "/opt/oscp/share/images"

style "default"
{
 GtkWidget::focus-line-width=0 GtkWidget::focus-padding=0  xthickness=0  ythickness=0
 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.bmp" }
  image { function=BOX file="blank.bmp" }
}}
style "pixmap_wide" {
 GtkProgressBar::min-horizontal-bar-height=24
 GtkProgressBar::min-vertical-bar-width=24
 ythickness=1 xthickness=1

 fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=PRELIGHT file="a-blank-wide.bmp" }
  image { function=BOX file="blank-wide.bmp" }
}}
#class "GtkButton" style "pixmap"
#class "GtkButton" style "default"
class "GtkProgressBar" style "pixmap_wide"
class "GtkWidget" style "default"
"""
###########//n900 styled//##########
 elif(id=='n900'):
######//pc styled (winamp skin)//#######
  if(style_me==3):
   gtk.stock_add([('i_prev',"",0,0,"")])
   ww=275*2; wh=116*2; local_gtkrc=""" pixmap_path "/opt/oscp/share/images"

style "default"
{
 GtkWidget::focus-line-width=0 GtkWidget::focus-padding=0  xthickness=0  ythickness=0
 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.bmp" }
  image { function=BOX file="blank.bmp" }
}}
class "GtkWidget" style "default"
"""
  else: local_gtkrc=""" pixmap_path "/opt/oscp/share/images"
style "default"
{ GtkWidget::interior-focus=20
# GtkRange::trough-border=0  GtkRange::slider-width=122  GtkRange::stepper-size=15
# GtkRange::stepper-spacing=0  GtkRange::trough-side-details=0
 GtkWidget::focus-line-width=0  GtkWidget::focus-padding=0  xthickness=0  ythickness=0
 GtkScrollbar::slider_width=30
 GtkRange::slider-width=30
 GtkScale::slider-width=30
 GtkScrolledWindow::slider-width=30

# GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
#fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
#bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
#base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
#text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.bmp" }
  image { function=BOX file="blank.bmp" }
}}
style "pixmap_wide" {
 GtkProgressBar::min-horizontal-bar-height=48
 GtkProgressBar::min-vertical-bar-width=48
 ythickness=1 xthickness=1

 fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=PRELIGHT file="a-blank-wide.bmp" }
  image { function=BOX file="blank-wide.bmp" }
}}
class "GtkButton" style "pixmap"
class "GtkProgressBar" style "pixmap_wide"
class "GtkWidget" style "default"
"""
#######//system style//##########
 else: local_gtkrc=""




 l20="[0]";l21="[1]";l22="[2]";l23="[3]";l24="[4]";l25="[5]";l26="[6]";l27="[7]";l28="[8]"
 l29="[9]";l30="m";l31="[F]"

 # buttons (icons)
 if(iconset==0):
  l0="|";  l1="<";  l2=">";  l3="=";  l4="[]"  # |, <, >, =, []
  l5="/\\";  l6="\\/" # /\\ \\/
  l00="R"; l01="S"; l02="[x]"; l03="conn"; l04="cquit"; l05="sloacti"; # Rep, Shu, [x], conn, cquit, sloacti
  l10="|<"; l11="<<"; l12="||"; l13=">>"; l14=">|"; l15="|>"; l16="[]";
  l17=l5+l5; l18=l6+l6; l19=l1+l2
 elif(abs(iconset)==1):
  l0=u"\u25ae"; l1=u"\u25c0"; l2=u"\u25b6"; l3="="; l4=u"\u25a0"; l5=u"\u25b2"; l6=u"\u25bc"
  l00="R"; l01="S"; l02=u"\u2716"; l03=u"\u2706"; l04=u"\u2612"; l05=u"\u2611";
  l10=l0+l1; l11=l1+l1; l12=l0+l0; l13=l2+l2; l14=l2+l0; l15=u"\u25b6"; l16=u"\u25a0";
  l17=l5+l5; l18=l6+l6; l19=l1+l2
 elif(abs(iconset)==2):
  l0=u"\u25aa"; l1=u"\u25c4"; l2=u"\u25ba"; l3="="; l4=u"\u2587";
  l5=u"\u25b2"; l6=u"\u25bc"
  #l5=u"\u2191"; l6=u"\u2193"
  l00="R"; l01="S"; l02="[x]"; l03="conn"; l04="cquit"; l05="sloacti" # Rep, Shu, [x], conn, cquit, sloacti
  l10=l0+l1; l11=l1+l1; l12=l0+l0; l13=l2+l2; l14=l2+l0; l15=l2; l16=l4;
  l17=l5+l5; l18=l6+l6; l19=l1+l2

 def state2label(self, s):
  if(s==0): return self.l2+self.l1 #uninited (no slave)
  elif(s==1): return self.l1+self.l2 #slave forked
  elif(s==2): return self.l16 #alive(stopped)
  elif(s==3): return self.l15 #playing
  elif(s==4): return self.l12 #paused
  elif(s==5): return self.l2+self.l3 #loading(send load request to slave)
  elif(s==6): return self.l3+self.l2 #loading2(slave reacted to load request)
  elif(s==12): return self.l2+self.l1 #alive(stopping)
  elif(s==14): return self.l2+self.l0 #pausing
  else: return "??"

 def mm(self, a): return a*10*self.dpi/254

 def s2t(self, s):
  s=int(s)
  if(s<0): s=0
  m=s/60
  if(m>0): s-=m*60
  if(m<10): tm="0"+str(m)
  else: tm=str(m)
  if(s<10): ts="0"+str(s)
  else: ts=str(s)
  return tm+":"+ts

 def set_ln(self, a2): # listname
  if(self.small==1): self.w0.set_title(a2)
  else: self.l_listname.set_text(a2)

 def set_cn(self, a2): # curname
  if(self.style_me==3): self.l_curname.set_text(a2); return
  if(self.small==1): self.w0.set_title(a2)
  else: self.l_curname.set_text(a2)

 def say(self, a):
  if(self.cfail==0): self.sock.sendall(a+"\n")

 def volI(self, widget, data="None"): self.say("VOL+")
 def volD(self, widget, data="None"): self.say("VOL-")
 def rep(self, widget, data="None"): self.say("REPEAT")
 def shu(self, widget, data="None"): self.say("SHUFFLE")
 def prev(self, widget, data="None"): self.say("PREV")
 def rwnd(self, widget, data="None"): self.say("RWND")
 def pause(self, widget, data="None"): self.say("PAUSE")
 def ffwd(self, widget, data="None"):
  if(self.state==3): self.say("FFWD")
  elif(self.state==4): self.pause(None,None)
  else: self.loadcur()
 def next(self, widget, data="None"): self.say("NEXT")
 def play(self, widget, data="None"): self.say("LOAD")
 def loadcur(self): self.load(self.lcur)
 def load(self, n): self.say("LOAD "+str(n))
 def playpause(self, widget, data="None"):
  if(self.state==3 or self.state==4): self.say("PAUSE")
  else:
   if(self.lcur<=0): self.say("NEXT")
   else: self.loadcur()
 def stop(self, widget, data="None"): self.say("STOP")
 def quitc(self, widget, data="None"): self.say("QUIT")
 def conn(self, widget, data="None"): self.mkconn()

 def show_vol(self, a2):
  if(self.style_me!=3):
   if(self.volume_as_slider==0): self.l_vol.set_label("Vol "+a2)
   else: self.pb_2.set_fraction(float(a2)/100.0); self.pb_2.set_text(str(a2)+"%")
  else:
  # volbar: 136x28  offs: 214,114  posha: 16
#  self.pb_2.set_fraction(float(a2)/100.0); self.pb_2.set_text(str(a2)+"%")
   x=int((136.0-28.0)*float(a2)/100.0)
   self.wa.move(self.eb_4,int(self.ss*(214+x)),int(self.ss*116))

 def seti(self, i, fn):
  pb=gtk.gdk.pixbuf_new_from_file(self.pixpa+fn)
  w=pb.get_width(); h=pb.get_height()
  spb=pb.scale_simple(int(self.ss*w),int(self.ss*h),gtk.gdk.INTERP_BILINEAR)
  i.set_from_pixbuf(spb)

 def show_shu(self, a2):
  if(self.style_me!=3):
   if(self.small==0): self.b_shu.set_label("Shu ["+a2+"]")
   else: self.b_shu.set_label("S:"+a2+"")
  else:
   if(a2=="0"): self.seti(self.b_shu.get_child(),"shu.png");
   else: self.seti(self.b_shu.get_child(),"shu2.png");
 def show_rep(self, a2):
  if(self.style_me!=3):
   if(self.small==0): self.b_rep.set_label("Rep ["+a2+"]")
   else: self.b_rep.set_label("R:"+a2+"")
  else:
   if(a2=="0"): self.seti(self.b_rep.get_child(),"rep.png");
   else: self.seti(self.b_rep.get_child(),"rep2.png");

 def tell_me_about(self,s): return (type(s), s)
 def parse_line(self,a,l):
  if(l<=1): return
  p=a.find("=")
  if(p<=0): p=l
  a1=a[0:p]
  #a2=a[p+1:]
  #a2=unicode(a[p+1:], 'iso8859-2') #.encode("utf-8")
  a2=a[p+1:].decode('latin2')
  #print self.tell_me_about(a2)
  #print a2

  if(a1=="TIME"):
   self.time=int(a2); self.l_time.set_label(self.s2t(a2))
   if(self.ttime>0):
    p=self.time*100/self.ttime;
    if(p<0): p=0;
    elif(p>100): p=100;
    if(self.style_me!=3):
     if(p!=self.lastperc): self.lastperc=p; self.pb_1.set_fraction(float(p)/100.0)
     self.pb_1.set_text(self.s2t(a2)+" ["+self.s2t(self.ttime)+"]")
    else: 
     # posbar: 496  offs: 32,144  posha: 58
     x=int((496.0-58.0)*float(p)/100.0)
     self.wa.move(self.eb_3,int(self.ss*(32+x)),int(self.ss*144))
  elif(a1=="STATE"):
   t=int(a2); self.state=t; self.l_state.set_label(self.state2label(t))
   if(self.iconset>=0): # play l15, pause l12
    if(t==3): self.b_playpause.set_label(self.l12)
    else:     self.b_playpause.set_label(self.l15)
   # doesn't work properly on n8x0
   #else:
   # if(t==3): self.b_playpause.set_image(self.i_pause)
   # else:     self.b_playpause.set_image(self.i_play)
  elif(a1=="TTIME"): self.ttime=int(a2); self.l_ttime.set_label(self.s2t(a2))
  elif(a1=="D"): self.set_cn(a2)
  elif(a1=="CURNAME"):
   self.curname=a2; self.set_cn(a2)
   if(self.id=="pc"): print " |> "+str(a2)
  elif(a1=="CUR"):
   c=int(a2); self.lcur=c
   #if(c>0): c-=1
   #ti = self.ts.iter_nth_child(None, c); path = self.ts.get_path(ti); print str(path)
   path=(c,); self.tv.scroll_to_cell(path);
   self.tv.set_cursor(c)
   #self.tv.set_cursor_on_cell(c)
   #print "cur: "+str(c)
  elif(a1=="LISTNAME"): self.set_ln(a2)
  elif(a1=="SHUFFLE"): self.show_shu(a2)
  elif(a1=="REPEAT"): self.show_rep(a2)
  elif(a1=="VOL"): self.show_vol(a2)
  elif(a1=="FREQ"):
   lab="";
   if(self.style_me!=3): lab="kHz "
   self.l_freq.set_label(" "+str(int(a2)/1000)+lab)
  elif(a1=="BITRATE"):
   t=int(a2); lab=""
   if(self.style_me!=3): lab="kbps "
   if(t>0): self.l_bitrate.set_label(" "+a2+lab)
   else: self.l_bitrate.set_label("  ")
  elif(a1=="CHAN"):
   self.l_chan.set_label(" "+a2+"ch ")
  elif(a1=="LIST_START"):
   self.ts.clear(); self.lcur=0; t=int(a2)
   if(t<0): t=0
   self.set_cn("New list: "+a2+" entries")
  elif(a1=="LIST_END"):
   if(self.curname==""): self.curname="."
  elif(a1[0:3]=="NAM"):
   p=a1.find("]")
   if(p<0): return
   p2=a2.find(",")
   if(p2<=0): return
   n=int(a1[5:p])
   t=int(a2[:p2])
   p2+=1; nam=a2[p2:]
   if(t<0): nam+="/"
   self.tv.get_model().append(None, row=(n, nam))
   self.lmax=n
  elif(a1[0:4]=="TYPE"): pass
  elif(a1=="COREQUIT"): self.set_cn(a2); self.clconn()
  #else: print "[unhandled msg: "+str(l)+","+a1+","+a2+"]"

 def tv_show(self, c): path=(c,); self.tv.scroll_to_cell(path)
 def tv_click(self, tv, ev):
  if ev.button == 1:
   p = tv.get_path_at_pos(int(ev.x), int(ev.y))
   if p is None: return
   path, col, x, y = p; a="LOAD "+str(tv.get_model()[path][0])
   self.say(a) # load current index

 def mrl(self, eb, ev): self.say("MAKE_RECURSIVE_LIST")
 def go_parent(self, eb, ev): self.load(0)
 def go_top(self, eb, ev): self.tv_show(0)
 def go_cur(self, eb, ev): self.tv_show(self.lcur)
 def go_end(self, eb, ev): self.tv_show(self.lmax)
 def go_pgup(self, eb, ev): pass
 def go_pgdn(self, eb, ev): pass

 def favSH(self, eb, ev):
  if(self.box_lnav3.flags() & gtk.VISIBLE):
   self.box_lnav3.hide();
   self.box_lnav2.hide();
  else:
   self.box_lnav3.show();
   self.box_lnav2.show();

 def favR(self, eb, ev):
  if(self.favRstate==0): self.favRstate=1; self.b_lfR.set_label("M");
  else: self.favRstate=0; self.b_lfR.set_label("m");

 def loadfav(self, eb, a, ev):
  if(a<0 or a>9): return
  if(self.favRstate==0): self.say("LOADFAV "+str(a))
  else: self.favR(None, None); self.say("SETFAV "+str(a))

 def pb1_click(self, eb, ev):
  #if(self.ttime<=0): print "no ttime"; return
  if(self.style_me!=3):
   t=round(ev.x*self.ttime/eb.get_allocation().width); self.say("SEEK "+str(t))
  else:
   # posbar: 496  offs: 32,144  posha: 58
   t=round((ev.x-58/2)*self.ttime/(eb.get_allocation().width-58));
   if(t<0): t=0
   if(t>self.ttime): t=self.ttime;
   #print "tt:"+str(self.ttime)+", t:"+str(t)
   self.say("SEEK "+str(t))

 def pb2_click(self, eb, ev):
  if(self.style_me!=3):
   t=round(ev.x*100/eb.get_allocation().width); self.say("VOLS "+str(t))
  else:
   # volbar: 136x28  offs: 220,114  posha: 16
   t=round((ev.x-16/2)*100/(eb.get_allocation().width-16));
   if(t<0): t=0
   if(t>100): t=100;
   print "v:"+str(t)
   self.say("VOLS "+str(t))

 def handle_data(self, s, cond):
  try: buf=self.hdb+s.recv(4096); self.hdb=""; l=len(buf); opos=0; pos=0
  except: l=0
  if(l<=0): self.hdb=""; self.clconn(); return 1
  while (self.cfail==0 and pos>=0 and pos<l):
   pos=buf.find("\n",opos)
   if pos==-1: self.hdb=buf[opos:]
   else: line=buf[opos:pos-1]; self.parse_line(line,pos-1-opos); opos=pos+1
  return 1

 def d(self, a): self.l_curname.set_text(a);

 def close(self, widget, data=None): self.w0.destroy()
 def delete_event(self, widget, event, data=None): return 0
 def destroy(self, widget, data=None): gtk.main_quit()

 def save_lasthost(self):
  if(self.HOST==""): return
  try: f=open(expanduser("~")+"/.oscp-remote.conf","wb")
  except: return
  if(self.PORT<=0 or self.PORT>65535): self.PORT=44322
  a="lasthost="+self.HOST+"\nlastport="+str(self.PORT)+"\n"
  f.write(a); f.close()
  #print "save_lasthost: "+a

 def load_lasthost(self):
  #print expanduser("~")+"/.oscp-remote.conf"
  try: f=open(expanduser("~")+"/.oscp-remote.conf","rb")
  except: return
  for line in f:
   if(line.startswith('lasthost=')): self.HOST=line[9:].rstrip()
   if(line.startswith('lastport=')):
    try: self.PORT=int(line[9:].rstrip())
    except: pass
  f.close()
  #print "load_lasthost: "+self.HOST+":"+str(self.PORT)

 def clconn(self):
  self.cfail=1
  try: gobject.source_remove(self.iowatch)
  except: pass
  try: self.sock.close()
  except: pass
  self.set_ln(""); self.set_cn("disconnected."); self.pb_1.set_fraction(0); self.ts.clear()

 def mkconn(self):
  self.clconn()
  self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM); self.sock.settimeout(3);
  try:    self.sock.connect((self.HOST, self.PORT)); self.cfail=0
  except: self.d('can\'t connect to: %s:%d' % (self.HOST, self.PORT))

  if(self.cfail==0):
   self.set_cn("connected to "+self.HOST)
   self.iowatch=gobject.io_add_watch(self.sock, gobject.IO_IN, self.handle_data)
   self.say("EHLO "+str(self.LISTTYPE))

 def getText_OK(self, ent, dia, res): dia.response(res)
 def getText(self, question, hint):
  dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
   gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, question)
  entry = gtk.Entry(); entry.set_text(hint)
  entry.connect("activate", self.getText_OK, dialog, gtk.RESPONSE_OK)
  dialog.vbox.pack_end(entry, 0, 0, 0); dialog.show_all(); ret=dialog.run()
  if(ret==-5): text=entry.get_text();
  else: text="-77777"
  dialog.destroy(); return text

 def connectto(self, widget, data=None):
  r=self.getText("Connect to HOST:PORT", self.HOST+":"+str(self.PORT))
  if(r=="-77777"): return
  h=""; p=self.PORT
  try: h,p=r.split(':')
  except: h=r
  try: self.PORT=int(p)
  except: pass
  if(h!=""): self.HOST=h; self.mkconn(); self.save_lasthost();

 def sloacti(self, widget, data=None): # spawn local oscp and connect to i
  self.set_cn("spawning local core")
  if(self.PORT<=0): self.PORT=44322
  os.system("killall oscp"); os.system(self.oscp_bin+" -a 1 -d 1 -L "+str(self.PORT)); time.sleep(1);
  self.HOST="127.0.0.1"; self.mkconn();

 def show_top(self, widget, data=None): self.lcur=0; self.tv.set_cursor(self.lcur); self.tv_show(self.lcur)
 def show_end(self, widget, data=None): self.lcur=self.lmax; self.tv_show(self.lcur); self.tv.set_cursor(self.lcur)
 def show_pgup(self, widget, data=None):
  self.lcur-=10
  if(self.lcur<0): self.lcur=0
  self.tv.set_cursor(self.lcur); self.tv_show(self.lcur)
 def show_pgdn(self, widget, data=None):
  self.lcur+=10
  if(self.lcur>self.lmax): self.lcur=self.lmax
  self.tv.set_cursor(self.lcur); self.tv_show(self.lcur)

 def key_press_event(self, widget, ev):
  k=ev.keyval
  if(k==65361): self.go_parent(None,None) #LEFT
  elif(k==65363 or k==65293): self.load(self.lcur) # RIGHT or ENTER
  elif(k==65362): # UP
   if(self.lcur>0): self.lcur-=1; self.tv_show(self.lcur); self.tv.set_cursor(self.lcur)
  elif(k==65364): # DOWN
   if(self.lcur<self.lmax): self.lcur+=1; self.tv_show(self.lcur); self.tv.set_cursor(self.lcur)
  elif(k==65360): self.show_top(None,None) # HOME
  elif(k==65367): self.show_end(None,None) # END
  elif(k==65365): self.show_pgup(None,None) # PGUP
  elif(k==65366): self.show_pgdn(None,None) # PGDN
  elif(k==113 or k==65307): self.w0.destroy() # q or ESC
  elif(k==112): self.playpause(None,None) # p
  elif(k==115): self.shu(None,None) # s
  elif(k==114): self.rep(None,None) # r
  elif(k==92): self.stop(None,None) # \\
  elif(k==91): self.prev(None,None) # [
  elif(k==93 or k==32): self.next(None,None) # ] or SPACE
  elif(k==44): self.rwnd(None,None) # ,
  elif(k==46): self.ffwd(None,None) # .
  elif(k==61 or k==43): self.volI(None,None) # = or +
  elif(k==95 or k==45): self.volD(None,None) # _ or -
  elif(k==59): self.mrl(None,None) # ; (make recursive list)
  elif(k==99): self.connectto(None,None) # c
  elif(k==120): self.quitc(None,None) # x
  elif(k==48): self.loadfav(None,0,None) # 0
  elif(k==49): self.loadfav(None,1,None) # 1
  elif(k==50): self.loadfav(None,2,None) # 2
  elif(k==51): self.loadfav(None,3,None) # 3
  elif(k==52): self.loadfav(None,4,None) # 4
  elif(k==53): self.loadfav(None,5,None) # 5
  elif(k==54): self.loadfav(None,6,None) # 6
  elif(k==55): self.loadfav(None,7,None) # 7
  elif(k==56): self.loadfav(None,8,None) # 8
  elif(k==57): self.loadfav(None,9,None) # 9
  elif(k==109): self.favR(None,None) # m
  elif(k==65477 and self.id=="n900"): self.prev(None,None) # n900: hw -
  elif(k==65476 and self.id=="n900"): self.next(None,None) # n900: hw +
  elif(k==65477 and self.id=="n8x0"): self.prev(None,None) # n800: hw -
  elif(k==65476 and self.id=="n8x0"): self.next(None,None) # n800: hw +
  elif(k==65475 and self.id=="n8x0"): pass # n800: hw []
  elif(k==65474 and self.id=="n8x0"): pass # n800: hw home (but will popup system menu)
  elif(k==65473 and self.id=="n8x0"): pass # n800: hw menu
  else:
   #print "key_press_event: "+str(k)
   self.set_cn("key: "+str(k))
   return False
  return True

 def nb2(self,w,h):
  b=gtk.Button(); b.set_focus_on_click(0);
  b.set_size_request(self.mm(w),self.mm(h)); hb = gtk.HBox(); vb = gtk.VBox()
  vb.pack_start(b, False, False); hb.pack_start(vb, False, False);
  b.show(); vb.show(); hb.show();
  return b

 def nb(self,lab,ico):
  b=self.nb2(self.defsize,self.defsize)
  if(self.iconset<0 and ico!=""):
   im = gtk.Image(); im.set_from_stock(ico, gtk.ICON_SIZE_BUTTON); #im.set_from_file("go-next.png");
   #im.show(); b.add(im);
   b.set_image(im)
  else: b.set_label(lab)
  return b

 def nbi(self,fn):
  i=gtk.Image(); self.seti(i,fn); i.show();
  eb=gtk.EventBox(); eb.add(i); eb.show();
  return eb

 def nbl(self,wid,txt,w,h,x,y):
  i=gtk.Label(); i.set_size_request(int(self.ss*w),int(self.ss*h)); i.show();
  eb=gtk.EventBox(); eb.add(i); eb.show();
  self.npu(wid,eb,x,y);
  return i

 def npu(self,a,b,x,y):
  a.put(b,int(self.ss*x),int(self.ss*y));

 def test(self,a,b):
  return True

 def eject(self, widget, data=None):
  self.playlist_showhide(None, None)
  return True

 def playlist_showhide(self, widget, data=None):
  if(self.w1.get_property("visible")): self.w1.hide(); self.seti(self.b_pl.get_child(),"pl.png");
  else: self.w1.show(); self.seti(self.b_pl.get_child(),"pl2.png");
  return True

 def posha(self, widget, data=None):
  #print "posha"
  return False

 def setup_window_wa(self):
  ss=self.ss;
  self.w0 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  if(self.ww<=0 or self.wh<=0): self.ww=self.mm(self.defsize)*8; self.wh=self.mm(self.defsize)*7
  self.ww=int(ss*self.ww); self.wh=int(ss*self.ww);
  self.w0.set_default_size(self.ww,self.wh)
  self.w0.set_border_width(0)
  self.w0.set_property("allow-shrink",False)

  self.w0.show();
  self.w0.connect("delete_event", self.delete_event); self.w0.connect("destroy", self.destroy)

  w=gtk.Fixed(); self.wa=w; w.set_has_window(1);
  i=self.nbi("main.png"); i.show; self.npu(w,i,0,0);
  ox=32; oy=176
  i=self.nbi("prev.png"); self.npu(w,i,ox,oy); i.connect("button_press_event",self.prev); self.b_prev=i;
  i=self.nbi("play.png"); self.npu(w,i,ox+23*2,oy); i.connect("button_press_event",self.play); self.b_prev=i;
  i=self.nbi("pause.png"); self.npu(w,i,ox+23*4,oy); i.connect("button_press_event",self.playpause); self.b_playpause=i;
  i=self.nbi("stop.png"); self.npu(w,i,ox+23*6,oy); i.connect("button_press_event",self.stop); self.b_prev=i;
  i=self.nbi("next.png"); self.npu(w,i,ox+23*8,oy); i.connect("button_press_event",self.next); self.b_prev=i;
  i=self.nbi("eject.png"); self.npu(w,i,272,oy+2); i.connect("button_press_event",self.eject); self.b_prev=i;

  i=self.nbi("shu.png"); self.npu(w,i,420-47*2,178); i.connect("button_press_event",self.shu); self.b_shu=i;
  i=self.nbi("rep.png"); self.npu(w,i,420,178); i.connect("button_press_event",self.rep); self.b_rep=i;
  i=self.nbi("eq.png"); self.npu(w,i,242*2-23*2,58*2); i.connect("button_press_event",self.test); self.b_eq=i;
  i=self.nbi("pl.png"); self.npu(w,i,242*2,58*2); i.connect("button_press_event",self.playlist_showhide); self.b_pl=i;

  i=self.nbi("mono.png"); self.npu(w,i,212*2,41*2);
  i=self.nbi("ster2.png"); self.npu(w,i,239*2,41*2);

  i=self.nbi("posbar.png"); self.npu(w,i,32,144); i.connect("button_press_event",self.pb1_click); self.eb_1=i;
  i=self.nbi("posha.png"); self.npu(w,i,32,144); self.eb_3=i;

  i=self.nbi("vol_27.png"); self.npu(w,i,214,114); i.connect("button_press_event",self.pb2_click); self.eb_2=i;
  i=self.nbi("volha.png"); self.npu(w,i,214,114); self.eb_4=i;

  i=gtk.Entry(1); i.set_has_frame(0); i.set_max_length(128); self.l_listname=i;
  i=self.nbl(w,"",533-221-4,69-53,220+2,52); i.set_alignment(0,0); i.set_selectable(1); self.l_curname=i; i.modify_font(pango.FontDescription("sans 14"));
  i=self.nbl(w,"",34-6,16,220+3,85); i.set_alignment(1,0); self.l_bitrate=i;	i.modify_font(pango.FontDescription("sans 14"));
  i=self.nbl(w,"",26-6,16,308+3,85); i.set_alignment(1,0); self.l_freq=i;	i.modify_font(pango.FontDescription("sans 14"));
  i=self.nbl(w,"--",40,32-6,44+6,46+6); i.set_alignment(0.5,0); self.l_state=i;	i.modify_font(pango.FontDescription("sans 22"));
  i=self.nbl(w,"00:00",60,32-6,95+26,48+6); i.set_alignment(0.5,0); self.l_time=i;	i.modify_font(pango.FontDescription("sans 22"));
  i=self.nbl(w,"00:00",53,16,95+48,50+36); i.set_alignment(0.5,0); self.l_ttime=i;i.modify_font(pango.FontDescription("sans 14"));
  i=self.nbl(w,"x ch",53,16,95+48,50+36+12); i.set_alignment(0.5,0); self.l_chan=i;i.modify_font(pango.FontDescription("sans 14"));

  w.show(); self.w0.add(w);

  self.pb_1=gtk.ProgressBar(); self.pb_2=gtk.ProgressBar()

  # prepare songlist
  self.ts = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING)
  self.tv = gtk.TreeView(self.ts)
  c=gtk.TreeViewColumn("Index", gtk.CellRendererText(), text=0); c.set_visible(0);
  self.tv.append_column(c)
  self.tv.append_column(gtk.TreeViewColumn("Name", gtk.CellRendererText(), text=1))
  self.tv.set_headers_visible(False)
  self.tv.show(); self.tv.connect('button-press-event' , self.tv_click)

  self.sw = gtk.ScrolledWindow(); self.sw.set_size_request(200,-1); self.sw.add(self.tv)
  self.sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)

  self.w1 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  self.w1.set_default_size(self.ww,self.wh)
  self.w1.set_border_width(0)
  self.w1.set_property("allow-shrink",False)

  vb=gtk.VBox(); vb.pack_start(self.sw); self.sw.show(); self.w1.add(vb); vb.show(); self.w1.show();

  self.w1.connect("key-press-event", self.key_press_event)
  self.w1.window.property_change(gtk.gdk.atom_intern("_HILDON_ZOOM_KEY_ATOM"), gtk.gdk.atom_intern("INTEGER"), 32, gtk.gdk.PROP_MODE_REPLACE, [1]);
  self.w1.connect("delete_event", self.playlist_showhide); self.w0.connect("destroy", self.playlist_showhide)
  self.w1.hide();

 def setup_window(self):
  self.w0 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  if(self.ww<=0 or self.wh<=0): self.ww=self.mm(self.defsize)*8; self.wh=self.mm(self.defsize)*7
  self.w0.set_default_size(self.ww,self.wh)
  self.w0.set_border_width(1)
  self.w0.connect("delete_event", self.delete_event); self.w0.connect("destroy", self.destroy)

  #settings = gtk.settings_get_default(); settings.props.gtk_button_images = True

  border_width=0
  self.b_rep = self.nb(self.l00, ""); self.b_rep.connect("clicked", self.rep, None)
  self.b_shu = self.nb(self.l01, ""); self.b_shu.connect("clicked", self.shu, None)
  self.b_prev = self.nb(self.l10, gtk.STOCK_MEDIA_PREVIOUS); self.b_prev.connect("clicked", self.prev, None)
  self.b_rwnd = self.nb(self.l11, gtk.STOCK_MEDIA_REWIND); self.b_rwnd.connect("clicked", self.rwnd, None)
  self.b_playpause = self.nb(self.l15, gtk.STOCK_MEDIA_PAUSE); self.b_playpause.connect("clicked", self.playpause, None)
  self.i_play=gtk.Image(); self.i_play.set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON);
  self.i_pause=gtk.Image(); self.i_pause.set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_BUTTON);
  #self.b_pause = self.nb(self.l12, gtk.STOCK_MEDIA_PAUSE); self.b_pause.connect("clicked", self.pause, None)
  self.b_ffwd = self.nb(self.l13, gtk.STOCK_MEDIA_FORWARD); self.b_ffwd.connect("clicked", self.ffwd, None)
  self.b_next = self.nb(self.l14, gtk.STOCK_MEDIA_NEXT); self.b_next.connect("clicked", self.next, None)
  #self.b_play = self.nb(self.l15, gtk.STOCK_MEDIA_PLAY); self.b_play.connect("clicked", self.play, None)
  self.b_stop = self.nb(self.l16, gtk.STOCK_MEDIA_STOP); self.b_stop.connect("clicked", self.stop, None)

  self.pb_1 = gtk.ProgressBar(adjustment=None) # song progress bar
  self.pb_1.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT); self.pb_1.show()
  self.eb_1 = gtk.EventBox(); self.eb_1.add(self.pb_1)
  self.eb_1.connect("button_press_event", self.pb1_click)

  self.pb_2 = gtk.ProgressBar(adjustment=None) # volume slider
  self.pb_2.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT); self.pb_2.show()
  self.eb_2 = gtk.EventBox(); self.eb_2.add(self.pb_2)
  self.eb_2.connect("button_press_event", self.pb2_click)

  #self.l_listname = gtk.Label("[listname]"); self.l_listname.set_selectable(1); self.l_listname.set_line_wrap(1);
  #self.l_curname = gtk.Label("[curname]"); self.l_curname.set_selectable(1); self.l_curname.set_line_wrap(1);
  #2.6+ self.l_listname.single_line_mode(1); self.l_curname.single_line_mode(1);
  self.l_listname = gtk.Entry(1); self.l_listname.set_has_frame(0); self.l_listname.set_max_length(128);
  self.set_ln("[listname]");
  self.l_curname = gtk.Entry(1); self.l_curname.set_has_frame(0); self.l_curname.set_max_length(128);
  self.set_cn("[curname]");
  self.l_time = gtk.Label("00:00");
  self.l_ttime = gtk.Label("00:00");
  self.l_freq = gtk.Label("x kHz");
  self.l_bitrate = gtk.Label("x kbps");
  self.l_chan = gtk.Label("x ch");
  self.l_state = gtk.Label("--");
  self.b_volD = self.nb("v-", gtk.STOCK_REMOVE); self.b_volD.connect("clicked", self.volD, None)
  self.b_volI = self.nb("v+", gtk.STOCK_ADD); self.b_volI.connect("clicked", self.volI, None)
  self.l_vol = gtk.Label("Vol ");
  self.b_sloacti = self.nb(self.l05, gtk.STOCK_EXECUTE); self.b_sloacti.connect("clicked", self.sloacti, None)
  self.b_quitc = self.nb(self.l04, gtk.STOCK_STOP); self.b_quitc.connect("clicked", self.quitc, None)
  self.b_conn = self.nb(self.l03, gtk.STOCK_NETWORK); self.b_conn.connect("clicked", self.connectto, None)
  self.b_x = self.nb(self.l02, gtk.STOCK_QUIT); self.b_x.connect("clicked", self.close, None)

  self.b_lfSH = self.nb(self.l31, ""); self.b_lfSH.connect("clicked", self.favSH, None)
  self.b_lfR = self.nb(self.l30, ""); self.b_lfR.connect("clicked", self.favR, None)
  self.b_lf0 = self.nb(self.l20, ""); self.b_lf0.connect("clicked", self.loadfav, 0, None)
  self.b_lf1 = self.nb(self.l21, ""); self.b_lf1.connect("clicked", self.loadfav, 1, None)
  self.b_lf2 = self.nb(self.l22, ""); self.b_lf2.connect("clicked", self.loadfav, 2, None)
  self.b_lf3 = self.nb(self.l23, ""); self.b_lf3.connect("clicked", self.loadfav, 3, None)
  self.b_lf4 = self.nb(self.l24, ""); self.b_lf4.connect("clicked", self.loadfav, 4, None)
  self.b_lf5 = self.nb(self.l25, ""); self.b_lf5.connect("clicked", self.loadfav, 5, None)
  self.b_lf6 = self.nb(self.l26, ""); self.b_lf6.connect("clicked", self.loadfav, 6, None)
  self.b_lf7 = self.nb(self.l27, ""); self.b_lf7.connect("clicked", self.loadfav, 7, None)
  self.b_lf8 = self.nb(self.l28, ""); self.b_lf8.connect("clicked", self.loadfav, 8, None)
  self.b_lf9 = self.nb(self.l29, ""); self.b_lf9.connect("clicked", self.loadfav, 9, None)
  self.box_lnav2 = gtk.VBox(0, 0); self.box_lnav2.set_border_width(0) #list nav
  self.box_lnav3 = gtk.VBox(0, 0); self.box_lnav3.set_border_width(0) #list nav

  self.b_go_parent = self.nb("..", gtk.STOCK_UNDO); self.b_go_parent.connect("clicked", self.go_parent, None)
  self.b_mrl = self.nb("mrl", gtk.STOCK_SELECT_ALL); self.b_mrl.connect("clicked", self.mrl, None)
  self.b_go_top = self.nb(self.l17, gtk.STOCK_GOTO_TOP); self.b_go_top.connect("clicked", self.go_top, None)
  self.b_go_pgup = self.nb(self.l5, gtk.STOCK_GO_UP); self.b_go_pgup.connect("clicked", self.go_pgup, None)
  self.b_go_cur = self.nb(self.l19, gtk.STOCK_GO_FORWARD); self.b_go_cur.connect("clicked", self.go_cur, None)
  self.b_go_pgdn = self.nb(self.l6, gtk.STOCK_GO_DOWN); self.b_go_pgdn.connect("clicked", self.go_pgdn, None)
  self.b_go_end = self.nb(self.l18, gtk.STOCK_GOTO_BOTTOM); self.b_go_end.connect("clicked", self.go_end, None)
  self.box_lnav = gtk.VBox(0, 0); self.box_lnav.set_border_width(0) #list nav

  gtk.Tooltips().set_tip(self.b_prev, "previous");
  gtk.Tooltips().set_tip(self.b_rwnd, "seek backward");
  #gtk.Tooltips().set_tip(self.b_pause, "pause");
  gtk.Tooltips().set_tip(self.b_ffwd, "seek forward");
  gtk.Tooltips().set_tip(self.b_next, "next");
  gtk.Tooltips().set_tip(self.b_playpause, "play/pause");
  #gtk.Tooltips().set_tip(self.b_play, "play");
  gtk.Tooltips().set_tip(self.b_stop, "stop");
  gtk.Tooltips().set_tip(self.b_volD, "decrease volume");
  gtk.Tooltips().set_tip(self.b_volD, "increase volume");
  gtk.Tooltips().set_tip(self.b_sloacti, "spawn local oscp and connect to it");
  gtk.Tooltips().set_tip(self.b_quitc, "quit core");
  gtk.Tooltips().set_tip(self.b_conn, "connect to core");
  gtk.Tooltips().set_tip(self.b_x, "quit remote");
  gtk.Tooltips().set_tip(self.b_go_parent, "go to parent dir");
  gtk.Tooltips().set_tip(self.b_mrl, "make recursive list");
  gtk.Tooltips().set_tip(self.b_go_top, "scroll to top");
  gtk.Tooltips().set_tip(self.b_go_pgup, "scroll one page up");
  gtk.Tooltips().set_tip(self.b_go_cur, "scroll to currently playing file");
  gtk.Tooltips().set_tip(self.b_go_pgdn, "scroll one page down");
  gtk.Tooltips().set_tip(self.b_go_end, "scroll to end");

  sep="  "
  self.ls1 = gtk.Label(sep);
  self.ls2 = gtk.Label(sep);
  self.ls3 = gtk.Label(sep);
  self.ls4 = gtk.Label(sep);
  self.ls5 = gtk.Label(sep);

  self.ts = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING)
  self.tv = gtk.TreeView(self.ts)
  c=gtk.TreeViewColumn("Index", gtk.CellRendererText(), text=0); c.set_visible(0);
  self.tv.append_column(c)
  self.tv.append_column(gtk.TreeViewColumn("Name", gtk.CellRendererText(), text=1))
  self.tv.set_headers_visible(False)
  self.tv.show(); self.tv.connect('button-press-event' , self.tv_click)

  self.sw = gtk.ScrolledWindow(); self.sw.set_size_request(200,-1); self.sw.add(self.tv)
  self.sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
#  self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
#  self.sw.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)

  self.box00 = gtk.HBox(0, 0); self.box00.set_border_width(0) #main box h
  self.box0 = gtk.VBox(0, 0); self.box0.set_border_width(0) #main box v
  self.box1 = gtk.HBox(0, 0); self.box1.set_border_width(border_width) #listname
  self.box2 = gtk.HBox(0, 0); self.box2.set_border_width(border_width) #curname
  self.box3 = gtk.HBox(0, 4); self.box3.set_border_width(border_width) #time, ttime, freq etc
  self.box4 = gtk.VBox(0, 0); self.box4.set_border_width(border_width) #buttons
  self.box5 = gtk.HBox(0, 0); self.box5.set_border_width(border_width) #buttons2
  self.boxl = gtk.HBox(0, 0); self.boxl.set_border_width(border_width) #list

#  pack_start(child, expand=True, fill=True, padding=0)
# expand=True means "I will fight for space"  expand=False means "I don't want more space"
# fill=True means "If I got more space, I will occupy it with my content"
# fill=False means "If I got more space, leave it blank" 

#  gtk.HBox(homogeneous=False, spacing=0)
# homogeneous : If True all children are given equal space allocations.
# spacing : The additional horizontal space between children in pixels

  #packing time
  #self.boxl.pack_start(self.box_lnav,0,1); self.box_lnav.show()
  self.boxl.pack_start(self.sw,1,1); self.sw.show();
  self.boxl.pack_start(self.ls4,0,0); self.ls4.show()

  self.box1.pack_start(self.l_listname,1,1); self.l_listname.show()
  self.box2.pack_start(self.l_curname,1,1); self.l_curname.show()
  self.box3.pack_start(self.ls5,0,0); self.ls5.show()
  self.box3.pack_start(self.l_state,0,0); self.l_state.show()
  #self.box3.pack_start(self.l_time,0,0); self.l_time.show()
  #self.box3.pack_start(self.l_ttime,0,0); self.l_ttime.show()
  self.box3.pack_start(self.eb_1,1,1); self.eb_1.show()
  self.box3.pack_start(self.l_freq,0,0); self.l_freq.show()
  self.box3.pack_start(self.l_chan,0,0); self.l_chan.show()
  self.box3.pack_start(self.l_bitrate,0,0); self.l_bitrate.show()
  #self.box4.pack_start(self.b_rwnd); self.b_rwnd.show()
  self.box5.pack_start(self.ls1); self.ls1.show()
  self.box5.pack_start(self.b_prev); self.b_prev.show()
  self.box5.pack_start(self.b_playpause); self.b_playpause.show()
  self.box5.pack_start(self.b_stop); self.b_stop.show()
  self.box5.pack_start(self.b_next); self.b_next.show()
  #self.box5.pack_start(self.b_pause); self.b_pause.show()
  #self.box5.pack_start(self.b_play); self.b_play.show()
  #self.box4.pack_start(self.b_ffwd); self.b_ffwd.show()
  self.box5.pack_start(self.ls2); self.ls2.show()
  if(self.volume_as_slider==1):
   self.box5.pack_start(self.eb_2,1,1); self.eb_2.show()
  else:
   self.box5.pack_start(self.l_vol); self.l_vol.show()
   self.box5.pack_start(self.b_volD); self.b_volD.show()
   self.box5.pack_start(self.b_volI); self.b_volI.show()
  self.box5.pack_start(self.ls3); self.ls3.show()
  self.box5.pack_start(self.b_shu); self.b_shu.show()
  self.box5.pack_start(self.b_rep); self.b_rep.show()

  self.box_lnav.pack_start(self.b_go_parent); self.b_go_parent.show()
  #self.box_lnav.pack_start(self.b_mrl); self.b_mrl.show()
  self.box_lnav.pack_start(self.b_go_top); self.b_go_top.show()
  #self.box_lnav.pack_start(self.b_go_pgup); self.b_go_pgup.show()
  self.box_lnav.pack_start(self.b_go_cur); self.b_go_cur.show()
  #self.box_lnav.pack_start(self.b_go_pgdn); self.b_go_pgdn.show()
  #self.box_lnav.pack_start(self.b_go_end); self.b_go_end.show()
  self.box_lnav.pack_start(self.b_lfSH); self.b_lfSH.show()
  self.box_lnav.pack_start(self.b_sloacti); self.b_sloacti.show()
  self.box_lnav.pack_start(self.b_quitc); self.b_quitc.show()
  self.box_lnav.pack_start(self.b_conn); self.b_conn.show()
  #self.box_lnav.pack_start(self.b_x); self.b_x.show()

  self.box_lnav2.pack_start(self.b_mrl); self.b_mrl.show()
  self.box_lnav2.pack_start(self.b_lf1); self.b_lf1.show()
  self.box_lnav2.pack_start(self.b_lf2); self.b_lf2.show()
  self.box_lnav2.pack_start(self.b_lf3); self.b_lf3.show()
  self.box_lnav2.pack_start(self.b_lf4); self.b_lf4.show()
  self.box_lnav2.pack_start(self.b_lf5); self.b_lf5.show()
  self.box_lnav3.pack_start(self.b_lfR); self.b_lfR.show()
  self.box_lnav3.pack_start(self.b_lf6); self.b_lf6.show()
  self.box_lnav3.pack_start(self.b_lf7); self.b_lf7.show()
  self.box_lnav3.pack_start(self.b_lf8); self.b_lf8.show()
  self.box_lnav3.pack_start(self.b_lf9); self.b_lf9.show()
  self.box_lnav3.pack_start(self.b_lf0); self.b_lf0.show()

  if(self.small==0): self.box0.pack_start(self.box1,0,1); self.box1.show()
  self.box0.pack_start(self.boxl,1,1); self.boxl.show()
  if(self.small==0): self.box0.pack_start(self.box2,0,1); self.box2.show()
  self.box0.pack_start(self.box3,0,1); self.box3.show()
  #self.box0.pack_start(self.box4,0,1); self.box4.show()
  self.box0.pack_start(self.box5,0,1); self.box5.show()

  self.box00.pack_start(self.box_lnav2,0,1);
  self.box00.pack_start(self.box_lnav3,0,1);
  if(self.i_like_buttons): self.box_lnav2.show(); self.box_lnav3.show()
  self.box00.pack_start(self.box_lnav,0,1); self.box_lnav.show()
  self.box00.pack_start(self.box0,1,1); self.box0.show()
  #self.box00.pack_start(self.box4,0,1); self.box4.show()

  self.w0.add(self.box00); self.box00.show();
  #packing end

 def __init__(self):
  #gtk.rc_parse("oscp-remote.gtkrc")
  gtk.rc_parse_string(self.local_gtkrc)

  print "style_me: "+str(self.style_me)
  if(self.style_me!=3): self.setup_window()
  else: self.setup_window_wa()

  self.w0.show() # w0.show_all()
  self.w0.connect("key-press-event", self.key_press_event)
  self.w0.window.property_change(gtk.gdk.atom_intern("_HILDON_ZOOM_KEY_ATOM"), gtk.gdk.atom_intern("INTEGER"), 32, gtk.gdk.PROP_MODE_REPLACE, [1]);

  argc=len(sys.argv)
  if(argc>=3): self.HOST=sys.argv[1]; self.PORT=int(sys.argv[2]); self.save_lasthost();
  else: self.load_lasthost()

  if(self.HOST==""): self.HOST="127.0.0.1"
  if(self.PORT<1 or self.PORT>65535): self.PORT=44322
  self.mkconn()

  if(self.id=="n900"):
   os.system("amixer -qc0 cset iface=MIXER,name='Jack Bias Switch' on")
   dp_hsb_fremantle = '/org/freedesktop/Hal/devices/computer_logicaldev_input_1'
   dp_camfocus_fremantle = '/org/freedesktop/Hal/devices/platform_cam_focus'

   from dbus.mainloop.glib import DBusGMainLoop
   import dbus
   dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
   system_bus = dbus.SystemBus()
   system_bus.add_signal_receiver(self.handle_hsb, 'Condition','org.freedesktop.Hal.Device', None, dp_hsb_fremantle)
   system_bus.add_signal_receiver(self.handle_focus, 'Condition','org.freedesktop.Hal.Device', None, dp_camfocus_fremantle)

#   pixbuf = gtk.gdk.pixbuf_new_from_file("/opt/oscp/share/images/main.bmp")
#   pixmap, mask = pixbuf.render_pixmap_and_mask(); width, height = pixmap.get_size(); del pixbuf
#   self.w0.set_app_paintable(1); self.w0.window.set_back_pixmap(pixmap, 0)
#   x, y = self.b_go_parent.get_size_request(); print str(x)+","+str(y)

 def main(self):
  gtk.main()

if __name__ == "__main__":
 orem = oscp_remote()
 orem.main()
